'use strict';

var _babelPluginTester = require('babel-plugin-tester');

var _babelPluginTester2 = _interopRequireDefault(_babelPluginTester);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _babelPluginTester2.default)({
  plugin: _index2.default,
  pluginName: 'styled-components-css-namespace',
  filename: __filename,
  // fixtures: path.join(__dirname, './fixtures'),
  snapshot: true,
  tests: [{
    title: 'adds namespace to simple styled-component',
    fixture: _path2.default.join(__dirname, './fixtures/simple_styled_component.js')
  }, {
    title: 'adds namespace to complex styled-component',
    fixture: _path2.default.join(__dirname, './fixtures/complex_styled_component.js')
  }, {
    title: 'uses a namespace specified in the options',
    pluginOptions: {
      cssNamespace: 'moreSpecific'
    },
    fixture: _path2.default.join(__dirname, './fixtures/complex_styled_component.js')
  }, {
    title: 'uses an array of namespaces specified in the options',
    pluginOptions: {
      cssNamespace: ['specific', 'verySpecific', 'extraSpecific']
    },
    fixture: _path2.default.join(__dirname, './fixtures/complex_styled_component.js')
  }, {
    title: 'does not transform a template string that is not a styled component',
    snapshot: false, // snapshot should be false because code should be unmodified
    fixture: _path2.default.join(__dirname, './fixtures/not_styled_component.js')
  }, {
    title: 'does not add extra selectors to child helper styles',
    fixture: _path2.default.join(__dirname, './fixtures/nested_helper_styled_component.js')
  }, {
    title: 'does not add namespace to keyframes',
    pluginOptions: {
      cssNamespace: 'specific'
    },
    fixture: _path2.default.join(__dirname, './fixtures/keyframes_styled_component.js')
  }, {
    title: 'adds namespace to extended styled-components',
    fixture: _path2.default.join(__dirname, './fixtures/extended_styled_component.js')
  }]
});